BinaryIntExpressionHelper (Groovy 5.0.6)

Package: org.codehaus.groovy.classgen.asm

## [Java] Class BinaryIntExpressionHelper

- org.codehaus.groovy.classgen.asm.BinaryIntExpressionHelper

-     public class BinaryIntExpressionHelper
      extends BinaryExpressionWriter

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class BinaryExpressionWriter` | `stdCompareCodes`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `BinaryIntExpressionHelper(WriterController wc)`
    `BinaryIntExpressionHelper(WriterController wc, MethodCaller arraySet, MethodCaller arrayGet)` Since: 2.5.0

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected void` | `doubleTwoOperands(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected int` | `getBitwiseOperationBytecode(int type)`
    `` | `protected int` | `getCompareCode()`
    `` | `protected ClassNode` | `getDevisionOpResultType()`
    `` | `protected ClassNode` | `getNormalOpResultType()`
    `` | `protected int` | `getShiftOperationBytecode(int type)`
    `` | `protected int` | `getStandardOperationBytecode(int type)`
    `` | `protected void` | `removeTwoOperands(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected boolean` | `supportsDivision()`
    `` | `protected void` | `writeMinusMinus(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected void` | `writePlusPlus(org.objectweb.asm.MethodVisitor mv)`
    `` | `protected boolean` | `writeSpaceship(int type, boolean simulate)` writes the spaceship operator, type should be COMPARE_TO
    `` | `protected boolean` | `writeStdCompare(int type, boolean simulate)` writes a std compare.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class BinaryExpressionWriter` | `arrayGet, arraySet, doubleTwoOperands, getArrayGetCaller, getArrayGetResultType, getArraySetCaller, getBitwiseOperationBytecode, getCompareCode, getController, getDevisionOpResultType, getNormalOpResultType, getShiftOperationBytecode, getStandardOperationBytecode, removeTwoOperands, setArraySetAndGet, supportsDivision, write, writeBitwiseOp, writeDivision, writeMinusMinus, writePlusPlus, writePostOrPrefixMethod, writeShiftOp, writeSpaceship, writeStdCompare, writeStdOperators`

- - ### Constructor Detail

    - #### public BinaryIntExpressionHelper(WriterController wc)

    - #### public BinaryIntExpressionHelper(WriterController wc, MethodCaller arraySet, MethodCaller arrayGet)

      Since:
        2.5.0

  - ### Method Detail

    - #### @Override
      protected void doubleTwoOperands(org.objectweb.asm.MethodVisitor mv)

    - #### @Override
      protected int getBitwiseOperationBytecode(int type)

    - #### @Override
      protected int getCompareCode()

    - #### @Override
      protected ClassNode getDevisionOpResultType()

    - #### @Override
      protected ClassNode getNormalOpResultType()

    - #### @Override
      protected int getShiftOperationBytecode(int type)

    - #### @Override
      protected int getStandardOperationBytecode(int type)

    - #### @Override
      protected void removeTwoOperands(org.objectweb.asm.MethodVisitor mv)

    - #### @Override
      protected boolean supportsDivision()

    - #### @Override
      protected void writeMinusMinus(org.objectweb.asm.MethodVisitor mv)

    - #### @Override
      protected void writePlusPlus(org.objectweb.asm.MethodVisitor mv)

    - #### @Override
      protected boolean writeSpaceship(int type, boolean simulate)

      writes the spaceship operator, type should be COMPARE_TO

      Parameters:
        `type` - the token type
      Returns:
        true if a successful spaceship operator write

    - #### @Override
      protected boolean writeStdCompare(int type, boolean simulate)

      writes a std compare. This involves the tokens IF_ICMPEQ, IF_ICMPNE, IF_ICMPEQ, IF_ICMPNE, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE and IF_ICMPLT

      Parameters:
        `type` - the token type
      Returns:
        true if a successful std compare write